/***************************************************************************
 *            sample.h
 *
 *  Copyright  2006  Florent Berthaut
 *  florentberthaut@no-log.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#ifndef _SAMPLE_H
#define _SAMPLE_H

#include <jack/types.h>
#include <iostream>
#include <stdio.h>
#include <sndfile.h>
#include <samplerate.h>
#include <string.h>


class sample
{
	public:
		sample();	
		~sample();	
		
		std::string getName();
		std::string getAbsoluteName();
		std::string getRelativeName();
		
		int tryLoad(char*,char*,std::string);
		int load(char*);
		void unload();
		void processFileName(std::string,std::string);
	
		void addUser();
		int getNbUsers();
		void removeUser();

		jack_default_audio_sample_t getSound(int,int);
		inline int getChannelsCount(){return channelsCount;};
		inline long getFramesCount(){return framesCount;};
		inline bool isLoaded(){return loaded;};	
		jack_default_audio_sample_t** getBuffers();
		void setSampleRate(int);

	private:
		std::string name;
		std::string absoluteName;
		std::string relativeName;
		jack_default_audio_sample_t** buffers;
		int channelsCount;
		int sampleRate;
		long framesCount; 
		bool loaded;
		int nbUsers;
};



#endif /* _SAMPLE_H */
